# vyos_static_route – Manage static IP routes on Vyatta VyOS network devices

New in version 2.4.

- Synopsis
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- This module provides declarative management of static IP routes on Vyatta VyOS network devices.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
admin_distance - |  | Admin distance of the static route.
aggregate - |  | List of static route definitions
mask - |  | Network prefix mask of the static route.
next_hop - |  | Next hop IP of the static route.
prefix - |  | Network prefix of the static route. `mask` param should be ignored if `prefix` is provided with `mask` value `prefix/mask`.

provider
dictionary

Deprecated
Starting with Ansible 2.5 we recommend using `connection: network_cli`.
For more information please see the Network Guide.

A dict object containing connection details.

| host string / required |  | Specifies the DNS host name or address for connecting to the remote device over the specified transport. The value of host is used as the destination address for the transport.
| password string |  | Specifies the password to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_PASSWORD` will be used instead.
| port integer | Default: 22 | Specifies the port to use when building the connection to the remote device.
| ssh_keyfile path |  | Specifies the SSH key to use to authenticate the connection to the remote device. This value is the path to the key used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_SSH_KEYFILE` will be used instead.
| timeout integer | Default: 10 | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error.
| username string |  | Configures the username to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_USERNAME` will be used instead.

state
-

Choices:
- present ←
- absent

State of the static route configuration.

## Notes

Note

- Tested against VyOS 1.1.8 (helium).
- This module works with connection `network_cli`. See the VyOS OS Platform Options.
- For more information on using Ansible to manage network devices see the Ansible Network Guide

## Examples

    - name: configure static route
      vyos_static_route:
        prefix: 192.168.2.0
        mask: 24
        next_hop: 10.0.0.1

    - name: configure static route prefix/mask
      vyos_static_route:
        prefix: 192.168.2.0/16
        next_hop: 10.0.0.1

    - name: remove configuration
      vyos_static_route:
        prefix: 192.168.2.0
        mask: 16
        next_hop: 10.0.0.1
        state: absent

    - name: configure aggregates of static routes
      vyos_static_route:
        aggregate:
          - { prefix: 192.168.2.0, mask: 24, next_hop: 10.0.0.1 }
          - { prefix: 192.168.3.0, mask: 16, next_hop: 10.0.2.1 }
          - { prefix: 192.168.3.0/16, next_hop: 10.0.2.1 }

    - name: Remove static route collections
      vyos_static_route:
        aggregate:
          - { prefix: 172.24.1.0/24, next_hop: 192.168.42.64 }
          - { prefix: 172.24.3.0/24, next_hop: 192.168.42.64 }
        state: absent

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
commands list | always | The list of configuration mode commands to send to the device Sample: ['set protocols static route 192.168.2.0/16 next-hop 10.0.0.1']

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Network Team. [network]

### Red Hat Support

More information about Red Hat’s support of this module is available from this Red Hat Knowledge Base article.

### Authors

- Trishna Guha (@trishnaguha)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.